#!/bin/bash


echo -84.054 09.938 > sjs.dat

if [ -f resultado_nlloc.dat ]
then
  rm resultado_nlloc.dat
fi

if [ -f resultado_hyp1.3.dat ]
then
  rm resultado_hyp1.3.dat
fi

if [ -f resultado_basico.dat ]
then
  rm resultado_basico.dat
fi


#ifort -o promediar_localizacion promediar_localizacion.f

cp ../hyp1.3/resultado_hyp13.dat .
cp ../basico/resultado_basico.dat .

cat ../basico/estaciones_usadas.dat > estaciones_usadas.dat
cat ../hyp1.3/estaciones_usadas.dat >> estaciones_usadas.dat

echo Creando archivo de resultados "t1"
cat resultado_* > t2
awk '{printf"%8.4f %8.4f %8.4f %8.4f %4d %4d %4d %4d %4d %4d\n",$1,$2,$3,$4,$5,$6,$7,$8,$9,$10}' t2 > t1
cat t1

etime=`tail -n 1 t1 | awk '{printf"%4s/%2s/%2s %2s:%2s:%2s\n",$5,$6,$7,$8,$9,$10}'`
echo $etime > etime.dat
head -n 1 t1 | awk '{print $5,$6,$7,$8,$9,$10}' > r23.dat
promediar_localizacion
rm t1
echo===========================
echo Mapa en GMT
echo===========================

# 109.3 km corresponden a 4.1 cm que es 1 grado en este mapa
# 109.3 km corresponden a 1.61 pulgadas
echo -84.054 09.938 > sjs.dat

if [ -f ../mw.dat ]
then
  cp ../mw.dat .
  mw=`cat mw.dat`
else
  mw="---"
  echo $mw > mw.dat
fi


pf=`awk '{printf"%4.1f\n", $5}' res.dat`
err_pro=`awk '{print $6}' res.dat`
elon=`awk '{print $1}' res.dat`
err_lon=`awk '{print $2}' res.dat`
elat=`awk '{print $3}' res.dat`
err_lat=`awk '{print $4}' res.dat`
rms=`awk '{print $7}' res.dat`
echo $rms > rms.dat
echo $err_pro > err_pro.dat
echo $elon $elat $pf $err_lon $err_lat > epi3.dat
desanjose=`awk '{a=sqrt((x0-$1)*(x0-$1)+(y0-$2)*(y0-$2));printf"%6.1f\n", a*109.3}' x0="$elon" y0="$elat" sjs.dat`

echo "-86.6 7.815 Estaciones usadas para el c\341lculo:" > info1.dat  
echo "-86.6 7.7  Origen (UTC): " >> info1.dat
echo "-86.6 7.6  Magnitud Momento (Mw)=" >> info1.dat
echo "-86.6 7.5  Distancia de San Jos\351(km)= " >> info1.dat
echo "-86.6 7.4  Profundidad (km)= " >> info1.dat
echo "-86.6 7.3  Longitud= " >> info1.dat
echo "-86.6 7.2  Latitud= " >> info1.dat
echo "-86.6 7.1  Error RMS= " >> info1.dat

echo "-85.0 7.6 " $mw  > info2.dat
echo "-85.0 7.5 " $desanjose  >> info2.dat
echo "-85.0 7.4 " $pf "\261" $err_pro >> info2.dat
echo "-85.0 7.3 " $elon  "\261" $err_lon >> info2.dat
echo "-85.0 7.2 " $elat  "\261" $err_lat >> info2.dat
echo "-85.0 7.1 " $rms >> info2.dat

echo "-85.0 7.7 " $etime  > info3.dat

gmt gmtset MAP_FRAME_TYPE PLAIN
gmt gmtset PS_MEDIA letter

gmt psbasemap -R-86.8/-81.8/7.0/11.7 -JM8.0i -B0/0 -P  -K -X0.3i -Y3.0i -V > p.ps
gmt grdimage ../surf.grd -R -JM -C../fondo.cpt -X0 -Y0 -I../gradients.grd -K  -O >> p.ps


gmt pscoast -R -J -N2/white -K  -Df -B -O -G150/150/150 >> p.ps
for j in /usr/local/gmt/parches/*.txt
do
  gmt psxy -R -J -O -K -B -G150/150/150 $j >> p.ps
done
gmt pscoast -R -J -N1/1.5 -W0.1 -X0 -K -Y0  -Df -B -O  -Lf-83.5/7.5/10.0/100.0+lkm >> p.ps


gmt psclip  -O -J -R /usr/local/gmt/contornos/isla_chira.txt -K >> p.ps
gmt grdimage /usr/local/gmt/ampl/t1.grd -R -JM -C/usr/local/gmt/ampl/s.cpt -X0 -Y0 -I/usr/local/gmt/ampl/t1.int -K  -O >> p.ps
gmt pscoast -R -J -N2/0.5,white -K  -Df -B -O  >> p.ps
gmt psclip  -C -O -K >> p.ps


makecpt -T-2000/5000/100 -Z -Cdem1 > n2.cpt


gmt psclip  -O -J -R /usr/local/gmt/contornos/contorno_costa_rica.txt -K >> p.ps
gmt grdimage /usr/local/gmt/ampl/t1.grd -R -JM -Cn2.cpt -X0 -Y0 -I/usr/local/gmt/ampl/t1.int -K  -O >> p.ps
gmt pscoast -R -J -N2/0.5,white,- -K  -Df -B -O  >> p.ps
gmt psclip  -C -O -K >> p.ps

gmt pscoast -R -J -N1/2,black -K  -Df -B -O -W0.5 >> p.ps

awk '{print $1+0.02,$2-0.01}' estaciones_usadas.dat | gmt psxy -R -JM -W0.1 -St0.1i -G0 -O -K >> p.ps
awk '{print $1,$2}' estaciones_usadas.dat | gmt psxy -R -JM -W0.1 -St0.1i -Ggreen -O -K >> p.ps

gmt psxy -R -JM -W0.5,black -Sc0.1i -Gyellow -O -K epi3.dat >> p.ps
gmt psxy -R -JM -W1.4,white -Sc0.2i -O -K epi3.dat >> p.ps
gmt psxy -R -JM -W1.2,white -Sc0.3i -O -K epi3.dat >> p.ps
gmt psxy -R -JM -W0.8,white -Sc0.4i -O -K epi3.dat >> p.ps
gmt psxy -R -JM -W0.6,white -Sc0.5i -O -K epi3.dat >> p.ps
gmt psxy -R -JM -W0.2,white -Sc0.6i -O -K epi3.dat >> p.ps



awk '{print $1,$2+0.25,"Epicentro"}' epi3.dat | gmt pstext -R  -F+f12p,Helvetica-Bold,white+jMC -JM -O -K -TO -Gblack >> p.ps

gmt pstext -R -J -O -F+f12p,Helvetica-Bold,black,+jBR -K -W0.1 -Gwhite -TO <<END>> p.ps
-81.85 7.08 Laboratorio de Ingenier\354a S\354smica (INII-UCR)
END

gmt pstext -R -JM -O -K  -F+f12p,Helvetica-Bold,green,+jTR  -G0 -W0.1 -TO <<END>> p.ps
-81.84 11.65 ESTIMACION REVISADA
END


gmt psxy -R -J -W2 -Gwhite -O -K <<END>> p.ps
-86.65 7.92
-84.95 7.92
-84.95 7.05
-86.65 7.05
-86.65 7.92
END
gmt pstext -R -JM -O -K -F+f11p,Helvetica,black,+jBL info1.dat >> p.ps
gmt pstext -R -JM -O -K -F+f11p,Helvetica,black,+jBR info2.dat >> p.ps
gmt pstext -R -JM -O -K -F+f11p,Helvetica-Bold,black,+jBR info3.dat >> p.ps

gmt psxy -R -JM -W0.1 -St0.113i -Ggreen -O -K <<END>> p.ps
-85.05 7.85
END

gmt psxy -R -JM -O <<END>>p.ps
END

convert p.ps -crop 590x560+15+25 epicentro.png

display epicentro.png &







#####################################################
#####################################################
###                Mapa origen
#####################################################
#####################################################

(
echo "Creando mapa origen"
cp epi3.dat ../origen/epi.dat
cp mw.dat ../origen
cd ../origen
modelo2.sh > salida.modelo.dat &
)

(
echo "Calculando distancias epicentrales"
cp epi3.dat ../distancias/epi.dat
cd ../distancias
calcular_distancia.sh
display lugares_cercanos.png &
)

echo "Calculando el tiempo origen"
fecha_origen.sh



echo Iniciando mapa detalle

#####################################################
#####################################################
###                Mapa detalle
#####################################################
#####################################################

e1=`awk '{print $1-0.25}' epi3.dat`
e2=`awk '{print $1+0.25}' epi3.dat`
e3=`awk '{print $2-0.25}' epi3.dat`
e4=`awk '{print $2+0.25}' epi3.dat`


gmt psbasemap -R$e1/$e2/$e3/$e4 -JM7.8i -B0/0 -P  -K -X0.3i -Y2.0i -V > p.ps
gmt pscoast -R -JM -N1/1 -N2/3,255/255/255 -W2 -X0 -Y0 -B -Df -O  -K -Lfx6.9i/0.8i/10.0/10.0 -Glightbrown -S0/149/255  >> p.ps
gmt psxy  /usr/local/gmt/fallas/*.falla -R -JM -B -O -K -W2,red >> p.ps

gmt psxy -O -JM -R  -W2,0/0/0 /usr/local/gmt/calles/calles_primarias_5 -K >> p.ps
gmt psxy -O -JM -R  -W2,50/50/50 /usr/local/gmt/calles/calles_secundarias_5 -K >> p.ps
awk -F\; '{print $1,$2}' /usr/local/gmt/lugares/cantones_parciales_5.dat  |gmt psxy -R -JM -O -K -G70 -Ss0.15i >> p.ps


# Dibuja resultado combinado
gmt psxy -R -JM -W1 -Sa0.34i -Gred -O -K epi3.dat >> p.ps
# Metodo basico
gmt psxy -R -JM -W2,black -Sa0.36i -O -K ../basico/epi.dat >> p.ps
# Metodo NLLOC
#gmt psxy -R -JM -W2,green -Sa0.36i -O -K ../nlloc/epi.dat >> p.ps
# Metodo Hypoinverse
gmt psxy -R -JM -W2,blue -Sa0.36i -O -K ../hyp1.3/epi.dat >> p.ps
# 
r1=`awk '{print $1+0.242}' epi3.dat`
r2=`awk '{print $2+0.235}' epi3.dat`
gmt pstext -R -JM -O -K -G0/255/0 -F+f16p,Helvetica,black,+jBR <<END>> p.ps
$r1 $r2 Mejores estimaciones usando programas distintos
END


r1=`awk '{print $1+0.242}' epi3.dat`
r2=`awk '{print $2-0.24}' epi3.dat`
gmt pstext -R -JM -O -K -G0 -W1 -G255/255/255 -F+f14p,Helvetica,black,+jBR <<END>> p.ps
$r1 $r2 Laboratorio de Ingenier\355a S\355smica (INII-UCR)
END

r1=`awk '{print $1-0.24}' epi3.dat`
r2=`awk '{print $2-0.241}' epi3.dat`
gmt pstext -R -JM -O -K -G0  -F+f14p,Helvetica,white,+jBL  <<END>> p.ps
$r1 $r2  M\351todos BASICO + HYP1.3
END

gmt psxy -R -JM -O  <<END>> p.ps
END
convert p.ps -crop 575x585+15+70 -quality 100 mapa_error.jpg

display mapa_error.jpg &


rm sjs.dat resultado_*.dat res.dat nom.dat hor.dat mw.dat

